import { SIZE_OF_EMPTY_ARRAY } from '@/constants/common';
import { openContextMenu } from '@/redux/contextMenu/contextMenu.slice';
import { MapSize } from '@/redux/map/map.types';
import { AppDispatch } from '@/redux/store';
import { Coordinate } from 'ol/coordinate';
import { Pixel } from 'ol/pixel';
import { getSearchResults } from '../mapSingleClick/getSearchResults';
import { handleDataReset } from '../mapSingleClick/handleDataReset';
import { handleSearchResultForRightClickAction } from './handleSearchResultForRightClickAction';

/* prettier-ignore */
export const onMapRightClick =
  (mapSize: MapSize, modelId: number, dispatch: AppDispatch) => async (coordinate: Coordinate, pixel: Pixel): Promise<void> => {
    dispatch(handleDataReset);
    dispatch(openContextMenu(pixel));

    const searchResults = await getSearchResults({ coordinate, mapSize, modelId });
    if (!searchResults || searchResults.length === SIZE_OF_EMPTY_ARRAY) {
      return;
    }

    handleSearchResultForRightClickAction({ searchResults, dispatch });
  };
